# ChunkCodecLibBlosc

## Warning: ChunkCodecLibBlosc is currently a WIP and its API may drastically change at any time.

This package implements the ChunkCodec interface for the following encoders and decoders
using the c-blosc library <https://github.com/Blosc/c-blosc>

1. `BloscCodec`, `BloscEncodeOptions`, `BloscDecodeOptions`

> [!CAUTION]
> c-blosc is currently not thread safe
> and has [other known issues](https://github.com/Blosc/c-blosc/issues/385) that are currently being worked around.

## Example

```julia-repl
julia> using ChunkCodecLibBlosc

julia> data = [0x00, 0x01, 0x02, 0x03];

julia> compressed_data = encode(BloscEncodeOptions(), data);

julia> decompressed_data = decode(BloscCodec(), compressed_data; max_size=length(data), size_hint=length(data));

julia> data == decompressed_data
true
```

The low level interface is defined in the `ChunkCodecCore` package.

"""
    BloscDecodingError(code)

Error for data that cannot be decoded.
"""
struct BloscDecodingError <: DecodingError
    code::Cint
end

function Base.showerror(io::IO, err::BloscDecodingError)
    print(io, "BloscDecodingError: blosc compressed buffer cannot be decoded, error code: ")
    print(io, err.code)
    nothing
end

"""
    struct BloscDecodeOptions <: DecodeOptions
    BloscDecodeOptions(; kwargs...)

Blosc decompression using c-blosc library: https://github.com/Blosc/c-blosc

# Keyword Arguments

- `codec::BloscCodec=BloscCodec()`
"""
struct BloscDecodeOptions <: DecodeOptions
    codec::BloscCodec
end
function BloscDecodeOptions(;
        codec::BloscCodec=BloscCodec(),
        kwargs...
    )
    BloscDecodeOptions(codec)
end

function try_find_decoded_size(::BloscDecodeOptions, src::AbstractVector{UInt8})::Int64
    check_contiguous(src)
    nbytes = Ref(Csize_t(0))
    ret = ccall((:blosc_cbuffer_validate, libblosc), Cint,
        (Ptr{Cvoid}, Csize_t, Ref{Csize_t}),
        src, length(src), nbytes
    )
    if iszero(ret) && nbytes[] ≤ typemax(Int64)
        # success, it is safe to decompress
        Int64(nbytes[])
    else
        # it is not safe to decompress. throw an error
        throw(BloscDecodingError(ret))
    end
end

function try_decode!(d::BloscDecodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    check_contiguous(dst)
    check_contiguous(src)
    # This makes sure it is safe to decompress.
    nbytes::Int64 = try_find_decoded_size(d, src)
    dst_size::Int64 = length(dst)
    if nbytes > dst_size
        NOT_SIZE
    else
        numinternalthreads = 1
        sz = ccall((:blosc_decompress_ctx, libblosc), Cint,
            (Ptr{Cvoid}, Ptr{Cvoid}, Csize_t, Cint),
            src, dst, dst_size, numinternalthreads
        )
        if sz == nbytes
            nbytes
        else
            throw(BloscDecodingError(sz))
        end
    end
end

"""
    struct BloscEncodeOptions <: EncodeOptions
    BloscEncodeOptions(; kwargs...)

Blosc compression using c-blosc library: https://github.com/Blosc/c-blosc

# Keyword Arguments

- `codec::BloscCodec=BloscCodec()`
- `clevel::Integer=5`: The compression level, between 0 (no compression) and 9 (maximum compression)
- `doshuffle::Integer=1`: Whether to use the shuffle filter.

  0 means not applying it, 1 means applying it at a byte level,
  and 2 means at a bit level (slower but may achieve better entropy alignment).
- `typesize::Integer=1`: The element size to use when shuffling.

  For implementation reasons, only `typesize` in `1:$(BLOSC_MAX_TYPESIZE)` will allow the
  shuffle filter to work.  When `typesize` is not in this range, shuffle
  will be silently disabled.
- `compcode::Union{Nothing, Integer}=nothing`: The integer code of the compressor to use.

  The available options are:
  `BLOSC_BLOSCLZ`, `BLOSC_LZ4`, `BLOSC_LZ4HC`, `BLOSC_ZLIB`, `BLOSC_ZSTD`

- `compressor::Union{Nothing, String}=nothing`: The string representing the type of compressor to use.

  For example, "blosclz", "lz4", "lz4hc", "zlib", or "zstd".
  Use `is_compressor_valid` to check if a compressor is supported.

  Setting both `compcode` and `compressor` throws an `ArgumentError`.
  If neither is set, the `BLOSC_LZ4` compressor is used.
"""
struct BloscEncodeOptions <: EncodeOptions
    codec::BloscCodec
    clevel::Int32
    doshuffle::Int32
    typesize::Int64
    compcode::Int32
end
function BloscEncodeOptions(;
        codec::BloscCodec=BloscCodec(),
        clevel::Integer=5,
        doshuffle::Integer=1,
        typesize::Integer=1,
        compcode::Union{Nothing, Integer}=nothing,
        compressor::Union{Nothing, String}=nothing,
        kwargs...
    )
    _clevel = Int32(clamp(clevel, 0, 9))
    check_in_range(0:2; doshuffle)
    _typesize = if typesize ∈ 2:BLOSC_MAX_TYPESIZE
        Int64(typesize)
    else
        Int64(1)
    end
    _compcode = if isnothing(compressor)
        if isnothing(compcode)
            BLOSC_LZ4
        else
            check_in_range((BLOSC_BLOSCLZ, BLOSC_LZ4, BLOSC_LZ4HC, BLOSC_ZLIB, BLOSC_ZSTD); compcode)
            Int32(compcode)
        end
    elseif isnothing(compcode)
        ChunkCodecLibBlosc.compcode(compressor)
    else
        throw(ArgumentError("compcode and compressor cannot both be set. Got\ncompcode => $(compcode)\ncompressor => $(repr(compressor))"))
    end::Int32
    BloscEncodeOptions(
        codec,
        _clevel,
        doshuffle,
        _typesize,
        _compcode,
    )
end

# TODO update this when segfault is fixed upstream.
decoded_size_range(e::BloscEncodeOptions) = Int64(0):Int64(e.typesize):Int64(2)^30

function encode_bound(::BloscEncodeOptions, src_size::Int64)::Int64
    clamp(widen(src_size) + widen(BLOSC_MAX_OVERHEAD), Int64)
end

function try_encode!(e::BloscEncodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    check_contiguous(dst)
    check_contiguous(src)
    src_size::Int64 = length(src)
    dst_size::Int64 = length(dst)
    check_in_range(decoded_size_range(e); src_size)

    # Clamp dst_size to avoid overflow bug
    # TODO Remove this when this is fixed upstream
    # https://github.com/Blosc/c-blosc/pull/390
    if dst_size - BLOSC_MAX_OVERHEAD > src_size
        dst_size = src_size + BLOSC_MAX_OVERHEAD
    end

    blocksize = Csize_t(0) # automatic blocksize
    numinternalthreads = Cint(1)
    sz = @ccall libblosc.blosc_compress_ctx(
        e.clevel::Cint,
        e.doshuffle::Cint,
        e.typesize::Csize_t,
        src_size::Csize_t,
        src::Ptr{Cvoid},
        dst::Ptr{Cvoid},
        dst_size::Csize_t,
        compname(e.compcode)::Cstring,
        blocksize::Csize_t,
        numinternalthreads::Cint,
    )::Cint
    if sz == 0
        NOT_SIZE
    elseif sz < 0
        error("Internal Blosc error: $(sz). This
            should never happen.  If you see this, please report it back
            together with the buffer data causing this and compression settings.
            $(e)
        ")
    else
        @assert sz ∈ 0:dst_size
        Int64(sz)
    end
end

# Constants and c wrapper functions ported to Julia from blosc.h https://github.com/Blosc/c-blosc/blob/3455c3810279ce709cf02f45beddbb31af418ab6/blosc/blosc.h

# `compcode` and `compname` functions are from https://github.com/JuliaIO/Blosc.jl/blob/25d663c607542cbebaea45542619726fec71bb5e/src/Blosc.jl#L339C1-L362C4

# The *_FORMAT symbols should be just 1-byte long
const BLOSC_VERSION_FORMAT   = Int64(2)   # Blosc format version, starting at 1

# Minimum header length
const BLOSC_MIN_HEADER_LENGTH = Int64(16)

# The maximum overhead during compression in bytes.  This equals to
#  BLOSC_MIN_HEADER_LENGTH now, but can be higher in future
#  implementations
const BLOSC_MAX_OVERHEAD = BLOSC_MIN_HEADER_LENGTH

# The maximum number of threads (for some static arrays)
const BLOSC_MAX_THREADS = Int64(256)

# Maximum typesize before considering source buffer as a stream of bytes
const BLOSC_MAX_TYPESIZE = Int64(255)   # Cannot be larger than 255

# Codes for shuffling
const BLOSC_NOSHUFFLE  = Int64(0)  # no shuffle
const BLOSC_SHUFFLE    = Int64(1)  # byte-wise shuffle
const BLOSC_BITSHUFFLE = Int64(2)  # bit-wise shuffle

"""
    is_compressor_valid(s::AbstractString)::Bool

Check if a compressor name is valid.
"""
function is_compressor_valid(s::AbstractString)
    '\0' ∈ s && return false
    ret = ccall((:blosc_compname_to_compcode, libblosc), Cint, (Cstring,), s)
    return ret != -1
end

# From https://github.com/JuliaIO/Blosc.jl/blob/25d663c607542cbebaea45542619726fec71bb5e/src/Blosc.jl#L339C1-L362C4
"""
    compcode(s::AbstractString)

Return a nonnegative integer code used internally by Blosc to identify the compressor.
Throws an `ArgumentError` if `s` is not the name of a supported algorithm.
"""
function compcode(s::AbstractString)
    compcode = ccall((:blosc_compname_to_compcode, libblosc), Cint, (Cstring,), s)
    compcode == -1 && throw(ArgumentError("unrecognized compressor $(repr(s))"))
    compcode
end

# From https://github.com/JuliaIO/Blosc.jl/blob/25d663c607542cbebaea45542619726fec71bb5e/src/Blosc.jl#L339C1-L362C4
"""
    compname(compcode::Integer)

Return the compressor name corresponding to the internal integer code used by Blosc.
Throws an `ArgumentError` if `compcode` is not a valid code.
"""
function compname(compcode::Integer)
    refstr = Ref(Ptr{UInt8}(0))
    retcode = ccall((:blosc_compcode_to_compname, libblosc), Cint, (Cint, Ref{Ptr{UInt8}}), compcode, refstr)
    retcode == -1 && throw(ArgumentError("unrecognized compcode $compcode"))
    unsafe_string(refstr[])
end


# The following is the original license info from blosc.h and LICENSE.txt

#=====================================================================
  Blosc - Blocked Shuffling and Compression Library

  Author: Francesc Alted <francesc@blosc.org>

  See LICENSE.txt for details about copyright and rights to use.
======================================================================#

#= contents of LICENSE.txt
BSD License

For Blosc - A blocking, shuffling and lossless compression library

Copyright (c) 2009-2018 Francesc Alted <francesc@blosc.org>
Copyright (c) 2019-present Blosc Development Team <blosc@blosc.org>

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this
   list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution.

 * Neither the name Francesc Alted nor the names of its contributors may be used
   to endorse or promote products derived from this software without specific
   prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
=#

using Random: Random
using ChunkCodecLibBlosc:
    ChunkCodecLibBlosc,
    BloscCodec,
    BloscEncodeOptions,
    BloscDecodeOptions,
    BloscDecodingError
using ChunkCodecCore: decode, encode
using ChunkCodecTests: test_codec
using Test: @testset, @test_throws, @test
using Aqua: Aqua

Aqua.test_all(ChunkCodecLibBlosc; persistent_tasks = false)

Random.seed!(1234)

@testset "default" begin
    test_codec(BloscCodec(), BloscEncodeOptions(), BloscDecodeOptions(); trials=100)
end
@testset "typesize" begin
    for i in 1:50
        test_codec(BloscCodec(), BloscEncodeOptions(;typesize=i), BloscDecodeOptions(); trials=10)
    end
end
@testset "compressors" begin
    for clevel in 0:9
        for compressor in ["blosclz", "lz4", "lz4hc", "zlib", "zstd"]
            test_codec(BloscCodec(), BloscEncodeOptions(;compressor, clevel), BloscDecodeOptions(); trials=10)
        end
    end
end
@testset "invalid options" begin
    @test BloscEncodeOptions(;clevel=-1).clevel == 0
    @test BloscEncodeOptions(;clevel=100).clevel == 9
    # typesize can be anything, but out of the range it gets set to 1
    e = BloscEncodeOptions(;typesize=typemax(UInt128))
    @test e.typesize == 1
    e = BloscEncodeOptions(;typesize=0)
    @test e.typesize == 1
    e = BloscEncodeOptions(;typesize=-1)
    @test e.typesize == 1
    e = BloscEncodeOptions(;typesize=ChunkCodecLibBlosc.BLOSC_MAX_TYPESIZE)
    @test e.typesize == ChunkCodecLibBlosc.BLOSC_MAX_TYPESIZE
    e = BloscEncodeOptions(;typesize=ChunkCodecLibBlosc.BLOSC_MAX_TYPESIZE+1)
    @test e.typesize == 1
    @test_throws ArgumentError BloscEncodeOptions(;compressor="")
    @test_throws ArgumentError BloscEncodeOptions(;compressor="asfdgfsdgrwwea")
    @test_throws ArgumentError BloscEncodeOptions(;compressor="blosclz,")
    @test_throws ArgumentError BloscEncodeOptions(;compressor="blosclz\0")
end
@testset "compcode and compname" begin
    @test ChunkCodecLibBlosc.compcode("blosclz") == 0
    @test ChunkCodecLibBlosc.is_compressor_valid("blosclz")
    @test ChunkCodecLibBlosc.compname(0) == "blosclz"

    @test_throws ArgumentError ChunkCodecLibBlosc.compcode("sdaffads")
    @test !ChunkCodecLibBlosc.is_compressor_valid("sdaffads")
    @test_throws ArgumentError ChunkCodecLibBlosc.compcode("sdaffads")
    @test_throws ArgumentError ChunkCodecLibBlosc.compname(100)

    @test !ChunkCodecLibBlosc.is_compressor_valid("\0")
end
@testset "errors" begin
    # check BloscDecodingError prints the correct error message
    @test sprint(Base.showerror, BloscDecodingError(1)) ==
        "BloscDecodingError: blosc compressed buffer cannot be decoded, error code: 1"
    # check that a truncated buffer throws a BloscDecodingError
    u = UInt8[0x00]
    c = encode(BloscEncodeOptions(), u)
    @test_throws BloscDecodingError decode(BloscDecodeOptions(), c[1:end-1])
    @test_throws BloscDecodingError decode(BloscDecodeOptions(), UInt8[0x00])
    # check that a buffer with extra data throws a BloscDecodingError
    @test_throws BloscDecodingError decode(BloscDecodeOptions(), [c; 0x00;])
    # check corrupting LZ4 encoding throws a BloscDecodingError
    u = zeros(UInt8, 1000)
    c = encode(BloscEncodeOptions(), u)
    c[end-5] = 0x40
    @test_throws BloscDecodingError decode(BloscDecodeOptions(), c)
end
@testset "public" begin
    if VERSION >= v"1.11.0-DEV.469"
        for sym in (:is_compressor_valid, :compcode, :compname)
            @test Base.ispublic(ChunkCodecLibBlosc, sym)
        end
    end
end

module ChunkCodecLibBlosc

using Blosc_jll: libblosc

using ChunkCodecCore:
    Codec,
    EncodeOptions,
    DecodeOptions,
    check_in_range,
    check_contiguous,
    DecodingError,
    MaybeSize,
    NOT_SIZE
import ChunkCodecCore:
    decode_options,
    try_decode!,
    try_encode!,
    encode_bound,
    try_find_decoded_size,
    decoded_size_range

export BloscCodec,
    BloscEncodeOptions,
    BloscDecodeOptions,
    BloscDecodingError

if VERSION >= v"1.11.0-DEV.469"
    eval(Meta.parse("public is_compressor_valid, compcode, compname"))
end

# reexport ChunkCodecCore
using ChunkCodecCore: ChunkCodecCore, encode, decode
export ChunkCodecCore, encode, decode

include("libblosc.jl")

"""
    struct BloscCodec <: Codec
    BloscCodec()

Blosc compression using c-blosc library: https://github.com/Blosc/c-blosc

Decoding does not accept any extra data appended to the compressed block.
Decoding also does not accept truncated data, or multiple compressed blocks concatenated together.

[`BloscEncodeOptions`](@ref) and [`BloscDecodeOptions`](@ref)
can be used to set decoding and encoding options.
"""
struct BloscCodec <: Codec end
decode_options(::BloscCodec) = BloscDecodeOptions()

include("encode.jl")
include("decode.jl")

end # module ChunkCodecLibBlosc
